{% macro inline_comparison(sample) -%}
  <div class="font-comparison">
    {% for font in varargs -%}
      <div class="font {{ font }}">{{ sample | safe }}</div>
    {% endfor -%}
  </div>
{%- endmacro %}
{% macro sample_block(font) -%}
  abcdefghijklmnopqrstuvwxyz
  ABCDEFGHIJKLMNOPQRSTUVWXYZ
  0123456789 (){}[]
  +-*/= .,;:!? #&amp;$%@|^
{%- endmacro %}
{% macro font_sample(font) -%}
  <details open>
    <summary>Font Sample ({{ font }})</summary>
    <pre class="font-sample {{ font }}">
Default:
  {{ sample_block() }}

<strong>Bold:
  {{ sample_block() }}</strong>

<em>Italic:
  {{ sample_block() }}</em>

<strong><em>Bold Italic:
  {{ sample_block() }}</em></strong>

&lt;!-- -- != := === &gt;= &gt;- &gt;=&gt; |-&gt; -&gt; &lt;$&gt;
&lt;/&gt; #[ |||&gt; |= ~@
</pre>
  </details>
{%- endmacro %}
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8"/>
  <title>@gitlab/fonts</title>
  <style>
    @font-face {
      font-family: 'Inter';
      font-weight: 100 900;
      font-style: normal;
      src: url('./fonts/Inter-Variable.woff2') format('woff2');
    }

    @font-face {
      font-family: 'Inter';
      font-weight: 100 900;
      font-style: italic;
      src: url('./fonts/Inter-Variable-Italic.woff2') format('woff2');
    }

    @font-face {
      font-family: 'GitLab Sans';
      font-weight: 100 900;
      font-style: normal;
      src: url('./fonts/GitLabSans.woff2') format('woff2');
    }

    @font-face {
      font-family: 'GitLab Sans';
      font-weight: 100 900;
      font-style: italic;
      src: url('./fonts/GitLabSans-Italic.woff2') format('woff2');
    }

    @font-face {
      font-family: 'GitLab Sans Hinted';
      font-weight: 100 900;
      font-style: normal;
      src: url('./fonts/GitLabSans.hinted.woff2') format('woff2');
    }

    @font-face {
      font-family: 'GitLab Sans Hinted';
      font-weight: 100 900;
      font-style: italic;
      src: url('./fonts/GitLabSans-Italic.hinted.woff2') format('woff2');
    }

    @font-face {
      font-family: "GitLab Mono";
      font-weight: 100 900;
      font-style: normal;
      src: url('./fonts/GitLabMono.woff2') format('woff2');
    }

    @font-face {
      font-family: "GitLab Mono";
      font-weight: 100 900;
      font-style: italic;
      src: url('./fonts/GitLabMono-Italic.woff2') format('woff2');
    }

    @font-face {
      font-family: 'JetBrains Mono';
      font-style: normal;
      src: url('./fonts/JetBrainsMono.woff2') format('woff2');
    }

    @font-face {
      font-family: 'JetBrains Mono';
      font-display: optional;
      font-weight: bold;
      src: url('./fonts/JetBrainsMono-Bold.woff2') format('woff2');
    }

    @font-face {
      font-family: 'JetBrains Mono';
      font-weight: normal;
      font-style: italic;
      src: url('./fonts/JetBrainsMono-Italic.woff2') format('woff2');
    }

    @font-face {
      font-family: 'JetBrains Mono';
      font-weight: bold;
      font-style: italic;
      src: url('./fonts/JetBrainsMono-BoldItalic.woff2') format('woff2');
    }

    html, body, .font {
      font-family: var(--font), sans-serif;
    }

    pre, code {
      font-family: var(--font), monospace;
    }

    body {
      margin: 40px auto;
      max-width: 650px;
      line-height: 1.6;
      font-size: 18px;
      color: #444;
      padding: 0 10px;
    }

    h1,
    h2,
    h3 {
      line-height: 1.2;
    }

    .font-sample {
      white-space: pre;
    }

    .jetbrains-mono {
      --font: "JetBrains Mono";
    }

    .gitlab-mono {
      --font: "GitLab Mono";
    }

    .gitlab-sans {
      --font: "GitLab Sans";
    }

    .gitlab-sans-hinted {
      --font: "GitLab Sans Hinted"
    }

    .inter {
      --font: "Inter";
    }

    .italic {
      font-style: italic;
    }

    .font-comparison {
      padding: 0.5rem;
    }

    .hinting-example .font {
      line-height: 21px !important;
      font-size: 14px !important;
      background-color: #fff !important;
      color: rgb(115, 114, 120) !important;
      font-weight: 400 !important;
    }

    .font-comparison .font::before {
      content: var(--font);
      display: inline-block;
      text-align: right;
      margin-right: 0.5rem;
      width: 9rem;
      color: darkgray;
      font-family: "GitLab Sans";
      font-size: 0.9rem;
      font-style: italic;
    }

    summary {
      cursor: pointer;
    }

    footer {
      margin-top: 1rem;
    }

    .dataframe {
      max-width: 870px;
      margin-left: -50px;
      font-size: 0.85rem;
      border-collapse: collapse;
    }

    .dataframe td {
      border: 1px solid black;
    }
  </style>
</head>
<body class="gitlab-sans">
<main>
  <h1>GitLab Fonts</h1>
  The <a href="https://gitlab.com/gitlab-org/frontend/fonts"><code class="gitlab-mono">@gitlab/fonts</code></a>
  package distributes fonts licensed under the OFL-1.1 to be used
  within GitLab products.

  <h2>GitLab Sans</h2>

  <section>
    This font is based on
    <a href="https://github.com/rsms/inter">Inter</a> (version 4), but with a few adjustments:

    <h3>Disambiguation of lowercase L (<code>l</code>)</h3>

    {{ inline_comparison("ĺ – ḹ – l̅ – ḷ – ľ – ł – ƚ – l̥","inter","gitlab-sans", "gitlab-sans-hinted") }}

    <h3 id="jm-distinct-italic">Distinct italic font file</h3>

    Same as Inter, we ship a proper italic font:

    {{ inline_comparison("ayfe ffi fi dach", "gitlab-sans", "gitlab-sans italic") }}

    <h3 id="hinting-example">Hinting example</h3>

    This is an example to look into Hinting of GitLab Sans:

    <div class="hinting-example">
      {{ inline_comparison("<em>#389369</em> · created 1 hour ago by Albert Salim", "inter", "gitlab-sans", "gitlab-sans-hinted") }}
    </div>
    More of GitLab Sans:
    <ul>
      <li>
        Specimen:
        <a href="./specimen/gitlab-sans" target="_blank">[Regular]</a> &middot;
        <a href="./specimen/gitlab-sans-italic" target="_blank">[Italic]</a>
      </li>
      <li>
        Download ttf:
        <a href="./fonts/GitLabSans.ttf" download>[Regular]</a> &middot;
        <a href="./fonts/GitLabSans-Italic.ttf" download>[Italic]</a>
      </li>
      <li>
        Download otf:
        <a href="./fonts/GitLabSans.otf" download>[Regular]</a> &middot;
        <a href="./fonts/GitLabSans-Italic.otf" download>[Italic]</a>
      </li>
    </ul>
    <hr/>
    {{ font_sample("gitlab-sans") }}
    {{ font_sample("gitlab-sans-hinted") }}
    <details>
      <summary>Font Metadata</summary>
      {{ metadata_table[0] | safe }}
    </details>
  </section>
  <h2>GitLab Mono</h2>
  <section>
    This font is based on <a href="https://github.com/JetBrains/JetBrainsMono">JetBrains Mono</a>, but with a few
    adjustments.

    <h3>Disabled ligatures by default</h3>
    {{ inline_comparison("=== >= >- >=> |-> ->", "jetbrains-mono", "gitlab-mono") }}

    <h3>Fixed the <a href="https://github.com/JetBrains/JetBrainsMono/issues/567">backtick bug</a></h3>
    {{ inline_comparison("` `A` `a` `` ```", "jetbrains-mono", "gitlab-mono") }}

    <h3 id="jm-distinct-italic">Distinct italic font file</h3>

    Same as JetBrains, we ship a proper italic font:

    {{ inline_comparison("ayfe ayfe |-> `This` ░", "gitlab-mono", "gitlab-mono italic") }}
    More of GitLab Mono:
    <ul>
      <li>
        Specimen:
        <a href="./specimen/gitlab-mono" target="_blank">[Regular]</a> &middot;
        <a href="./specimen/gitlab-mono-italic" target="_blank">[Italic]</a>
      </li>
      <li>
        Download ttf:
        <a href="./fonts/GitLabMono.ttf" download>[Regular]</a> &middot;
        <a href="./fonts/GitLabMono-Italic.ttf" download>[Italic]</a>
      </li>
    </ul>
    <hr/>
    {{ font_sample("gitlab-mono") }}
    <details>
      <summary>Font Metadata</summary>
      {{ metadata_table[1] | safe }}
    </details>
  </section>
  <h2>JetBrains Mono</h2>
  <section>
    Currently we also distribute <a href="https://github.com/JetBrains/JetBrainsMono">JetBrains Mono</a>.
  </section>
</main>
<footer>
  <small>
    <a href="https://gitlab.com/gitlab-org/frontend/fonts">Repository</a>
  </small>
</footer>
</body>
</html>
